#include "xpinball.h"

void collisions(data)
     Data *data;
{
  int len, i, cd, d_tmp, no_hits;
  Vector dd, vel, perp;
  double tmp1, tmp2, t_tmp, time;

  setvv(data->Pos[0], data->init_pos);
  copyv(vel, data->init_vel);
  data->c_time[0] = 0.0;
  data->total_time = 0.0;
  no_hits = 0;

  cd = NO_HIT;
  for (len=0; len<MAX_HIT; len++) {
    d_tmp = NO_HIT;
    time = INF_T;
    for(i=0; i<ND; i++) {
      if (i!=cd) {
	subv(dd, data->disk[i], data->Pos[len]);
	if ((tmp1 = dotv(vel, dd)) > 0.0) {
	  if ((tmp2=tmp1*tmp1-dotv(dd, dd)+data->asq) > 0.0) {
	    if ((t_tmp=tmp1-sqrt(tmp2))<time) {
	      d_tmp = i;
	      time = t_tmp;
	    }
	  }
	}
      }
    }
    if (time<INF_T) {
      no_hits++;
      cd = d_tmp;
      linear(data->Pos[no_hits], 1.0, data->Pos[no_hits-1], time, vel);
      linear(perp, data->ia, data->Pos[no_hits], -data->ia, data->disk[cd]);
      tmp1 = -2.0*dotv(vel, perp);
      linear(vel, 1.0, vel, tmp1, perp);
      data->c_time[no_hits] = time;
      data->total_time += time;
      data->col[no_hits-1] = cd + '1';
    } else
      break;
  }
  data->col[no_hits] = '\0';
  if(len==MAX_HIT)
    data->no_hits = no_hits-1;
  else {
    data->no_hits = no_hits;
    linear(data->Pos[no_hits+1], 1.0, data->Pos[no_hits], 3.0, vel);
  }
}

