#include "xpinball.h"
#include "xpinball_icon.h"

int bt_flag;

main(argc, argv)
     int argc;
     char *argv[];
{
  XtAppContext app;
  Widget toplevel, pb, main, commands, form;
  extern void exit();
  Data data;
  Dimension h;
  XtWidgetGeometry size;
  XSetWindowAttributes attrs;
  Pixmap bitmap;

  toplevel = XtVaAppInitialize (&app, "Demos", NULL, 0, 
			&argc, argv, NULL,
			NULL);

  bitmap = XCreatePixmapFromBitmapData (XtDisplay (toplevel),
        RootWindowOfScreen (XtScreen (toplevel)),
        iconbits, iconwidth, iconheight, 1, 0, 1);
  
  XtVaSetValues (toplevel,
        XmNiconPixmap, bitmap,
        NULL);
    
  main = XtVaCreateWidget ("main",
			xmPanedWindowWidgetClass, toplevel,
                        XmNsashWidth, 1,
                        XmNsashHeight, 1,
			NULL);
  
  commands = XtVaCreateManagedWidget ("commands",
		      xmRowColumnWidgetClass, main,
		      XmNorientation, XmHORIZONTAL,
 		      NULL);
  
  pb = XtVaCreateManagedWidget ("Quit",
				xmPushButtonGadgetClass, commands,
				NULL);
  XtAddCallback (pb, XmNactivateCallback, exit, NULL);
  
  pb = XtVaCreateManagedWidget ("Clear",
		xmPushButtonGadgetClass, commands,
		NULL);
  XtAddCallback (pb, XmNactivateCallback, Clear, (XtPointer) &data);

  pb = XtVaCreateManagedWidget ("Orbit",
		xmPushButtonWidgetClass, commands,
		NULL);
  XtAddCallback (pb, XmNactivateCallback, Orbit_cb, (XtPointer) &data);

  pb = XtVaCreateManagedWidget ("Poincare",
		xmPushButtonWidgetClass, commands,
		NULL);
  XtAddCallback (pb, XmNactivateCallback, Poincare_cb, (XtPointer) &data);

  form = XtVaCreateWidget ("main_form", xmFormWidgetClass, main,
			   XmNwidth,  400,
			   XmNheight, 300,
			   NULL);

  data.factor = 0.5;
  data.mag_scale = XtVaCreateManagedWidget ("Mag_Scale",
        xmScaleWidgetClass, form,
        XmNtopAttachment, XmATTACH_FORM,
        XmNbottomAttachment,     XmATTACH_FORM,
        XmNleftAttachment,       XmATTACH_FORM,
	XmNorientation, XmVERTICAL,
	XmNmaximum, 250,
        XmNminimum, 50,
        XmNvalue, (int) (100.0*data.factor),
        XmNshowValue, False,
        NULL);
  XtAddCallback(data.mag_scale, XmNvalueChangedCallback, Mag_Scale_cb,
		  (XtPointer) &data);

 /* Create a DrawingArea widget. */
  data.drawing_a = XtVaCreateWidget ("drawing_a",
		     xmDrawingAreaWidgetClass, form,
                     XmNtopAttachment, XmATTACH_FORM,
                     XmNbottomAttachment, XmATTACH_FORM,
                     XmNrightAttachment, XmATTACH_FORM,
                     XmNleftAttachment, XmATTACH_WIDGET,
		     XmNleftWidget, data.mag_scale,
		     XtVaTypedArg, XmNforeground, XmRString, "red", strlen("red")+1, 
		     XtVaTypedArg, XmNbackground, XmRString, "white", strlen("white")+1, 
		     NULL);

  /* add callback for all mouse and keyboard input events */
  XtAddCallback (data.drawing_a, XmNinputCallback, drawing_area_cb,
		 (XtPointer) &data);

  XtAddCallback (data.drawing_a, XmNexposeCallback, Expose_cb,
		 (XtPointer) &data);
  
  XtManageChild (data.drawing_a);
  XtManageChild(form);

  data.label1 = XtVaCreateManagedWidget ("label1",
		      xmLabelWidgetClass, main,
 		      NULL);
  XtVaGetValues(data.label1, XmNheight, &h, NULL);
  XtVaSetValues(data.label1, XmNpaneMaximum, h, XmNpaneMinimum, h, NULL);

  data.label2 = XtVaCreateManagedWidget ("label2",
		      xmLabelWidgetClass, main,
 		      NULL);
  XtVaGetValues(data.label2, XmNheight, &h, NULL);
  XtVaSetValues(data.label2, XmNpaneMaximum, h, XmNpaneMinimum, h, NULL);


  form = XtVaCreateWidget ("no lines", xmFormWidgetClass, main,
        XmNfractionBase,    8,
        NULL);

  data.a = 0.3;
  data.scale = XtVaCreateManagedWidget ("Radius Scale",
        xmScaleWidgetClass, form,
        XmNtopAttachment, XmATTACH_FORM,
        XmNbottomAttachment,     XmATTACH_FORM,
        XmNleftAttachment,       XmATTACH_POSITION,
        XmNleftPosition,         1,
        XmNrightAttachment,      XmATTACH_POSITION,
        XmNrightPosition,        7,
	XmNorientation, XmHORIZONTAL,
        XtVaTypedArg, XmNtitleString, XmRString, "Radius (%)", 11,
	XmNmaximum, 110,
        XmNminimum, 10,
        XmNvalue, (int) (data.a*200),
        XmNshowValue, True,
        NULL);
  size.request_mode = CWHeight;
  XtQueryGeometry(data.scale, NULL, &size);
  XtManageChild(form);
  XtVaSetValues(form, XmNpaneMaximum, size.height,
		XmNpaneMinimum, size.height, NULL);

  XtAddCallback(data.scale, XmNvalueChangedCallback, Scale_cb,
		  (XtPointer) &data);

  XtManageChild (main);
  init(&data);
  XtRealizeWidget (toplevel);
  /* see p347  */
  attrs.bit_gravity = ForgetGravity;
  XChangeWindowAttributes (XtDisplay(data.drawing_a), XtWindow(data.drawing_a), 
			   CWBitGravity, &attrs);

  XtAppMainLoop (app);
}

/* Callback routine for DrawingArea's input callbacks and the
 * PushButton's activate callback.  Determine which it is by
 * testing the cbs->reason field.
 */

void drawing_area_cb(widget, client_data, call_data)
     Widget widget;
     XtPointer client_data;
     XtPointer call_data;
{
  XmDrawingAreaCallbackStruct *cbs = 
    (XmDrawingAreaCallbackStruct *) call_data;
  Data *data = (Data *) client_data;
  XEvent *event = cbs->event;
  double tmp;
  
  if (cbs->reason == XmCR_INPUT) {
      /* activated by DrawingArea input event -- draw lines.
       * Button Down events anchor the initial point and Button
       * Up draws from the anchor point to the button-up point.
       */
    if (event->xany.type == ButtonPress) {
      if (event->xbutton.button==Button2)
	DrawTarget(data);
      else {
	data->init_pos.x = data->imag*(event->xbutton.x+dran()-data->offset.x);
	data->init_pos.y = -data->imag*(event->xbutton.y+dran()-data->offset.y);
	subv(data->init_vel, data->target, data->init_pos);
	tmp = 1.0/hypotv(data->init_vel);
	smulv(data->init_vel, tmp, data->init_vel);

	DrawRays(data);
      }
    } else {
      if((event->xany.type == ButtonRelease) && (event->xbutton.button==Button2)) {
	data->target.x = data->imag*(event->xbutton.x-data->offset.x);
	data->target.y = -data->imag*(event->xbutton.y-data->offset.y);
	DrawTarget(data);
      }
    }
  }
}

void init(data)
     Data *data;
{
  Display *dpy = XtDisplay(data->drawing_a);
  unsigned long valuemask;
  XGCValues values;
  void SetColour2();

  srandom(123);
  data->orbit = (char *) malloc(MAX_ORBIT);
  data->bin_orbit = (char *) malloc(MAX_ORBIT);
  setv(data->disk[0], -0.5, -LEN);
  setv(data->disk[1], 0.5, -LEN);
  setv(data->disk[2], 0, 2.0*LEN);
  setv(data->target, 0.0, 0.0);
  data->asq = data->a*data->a;
  data->ia = 1.0/data->a;
  data->no_hits = -1;
  data->new=0;
  data->poincare=0;
  values.foreground = BlackPixelOfScreen (XtScreen (data->drawing_a));
  values.background = WhitePixelOfScreen (XtScreen (data->drawing_a));
  valuemask = GCForeground;

  data->gc_ray = XCreateGC (dpy,  DefaultRootWindow(dpy), valuemask, &values);
  data->gc_old_ray = XCreateGC (dpy,  DefaultRootWindow(dpy), valuemask, &values);
  data->gc_orbit = XCreateGC (dpy,  DefaultRootWindow(dpy), valuemask, &values);
  data->gc_old_orbit = XCreateGC (dpy,  DefaultRootWindow(dpy), valuemask, &values);
  data->gc_disk = XCreateGC (dpy,  DefaultRootWindow(dpy), valuemask, &values);
  values.function = GXxor;
  valuemask = (GCForeground | GCFunction);
  data->gc_target1 = XCreateGC (dpy,  DefaultRootWindow(dpy), valuemask, &values);
  data->gc_target2 = XCreateGC (dpy,  DefaultRootWindow(dpy), valuemask, &values);


  (void) SetColour(data->drawing_a, data->gc_target1, "white");
  SetTwoColours(data->drawing_a, data->gc_target2, "LightPink", "grey90");
  SetTwoColours(data->drawing_a, data->gc_ray, "DarkGreen", "green");
  SetTwoColours(data->drawing_a, data->gc_old_ray, "LawnGreen", "yellow");
  SetTwoColours(data->drawing_a, data->gc_orbit, "NavyBlue", "blue");
  SetTwoColours(data->drawing_a, data->gc_old_orbit, "cyan", "yellow");
  SetTwoColours(data->drawing_a, data->gc_disk, "LightSteelBlue", "black");

/*
  SetColour2(data->drawing_a, data->gc_ray, 20, 120, 20);
  SetColour2(data->drawing_a, data->gc_old_ray, 135, 255, 135);
  SetColour2(data->drawing_a, data->gc_disk, 0, 70, 255);
  SetColour2(data->drawing_a, data->gc_target1, 180, 0, 0);
  SetColour2(data->drawing_a, data->gc_target2, 255, 128, 128);
*/
}

void SetTwoColours(w, gc, color, default_col)
     Widget w;
     GC gc;
     String color, default_col;
{
  if (SetColour(w, gc, color))
    return;
  else
    (void) SetColour(w, gc, default_col);
}

int SetColour(w, gc, color)
     Widget w;
     GC gc;
     String color;
{
  Colormap cmap = DefaultColormapOfScreen (XtScreen (w));
  XColor col;
  Display *dpy = XtDisplay(w);

  col.flags = DoRed | DoGreen | DoBlue;
  if(!XParseColor(dpy, cmap, color, &col))
    fprintf(stderr, "Color name %s not in database\n", color);
  if(!XAllocColor(dpy, cmap, &col)) {
    char buf[32];
    sprintf(buf, "Can't alloc %s", color);
    XtWarning(buf);
    return(0);
  }
  XSetForeground (dpy, gc, col.pixel);
  return(1);
}


void SetColour2(w, gc, red, green, blue)
     Widget w;
     GC gc;
     long red, green, blue;
{
  Display *dpy = XtDisplay(w);
  Colormap cmap = DefaultColormapOfScreen (XtScreen (w));
  XColor color;

  color.red = (red << 8);
  color.green = (green << 8);
  color.blue = (blue << 8);

  XFreeColors (XtDisplay (w), cmap, &color.pixel, 1, 0);
  if(!XAllocColor(dpy, cmap, &color)) {
    puts("Couldn't XAllocColour");
  }
  XSetForeground (dpy, gc, color.pixel);
}


void DrawDisks(data)
     Data *data;
{
  int i;
  XArc arcs[ND];
  Display *dpy = XtDisplay(data->drawing_a);

  XClearWindow(dpy, XtWindow(data->drawing_a));

  for(i=0; i<ND; i++) {
    arcs[i].x = (short) (data->mag*(data->disk[i].x - data->a) + data->offset.x);
    arcs[i].y = (short) (-data->mag*(data->disk[i].y + data->a) + data->offset.y);
    arcs[i].width = (short) (data->mag*2.0*data->a);
    arcs[i].height = (short) (data->mag*2.0*data->a);
    arcs[i].angle1 = 0;
    arcs[i].angle2 = 360*64;
  }

  XFillArcs(dpy, XtWindow(data->drawing_a), data->gc_disk, arcs, ND);
}

void DrawTarget(data)
     Data *data;
{
  Coord pos;

  Display *dpy = XtDisplay(data->drawing_a);
  pos.x = (short) (data->mag*data->target.x + data->offset.x);
  pos.y = (short) (-data->mag*data->target.y + data->offset.y);
  XDrawRectangle(dpy, XtWindow(data->drawing_a), data->gc_target2, pos.x-1,
		 pos.y-1, 3, 3);
  XFillRectangle(dpy, XtWindow(data->drawing_a), data->gc_target1, pos.x,
		 pos.y, 2, 2);
}

void DrawRays(data)
     Data *data;
{
  int i;
  Display *dpy = XtDisplay(data->drawing_a);

  if(data->new)
    XDrawSegments(dpy, XtWindow(data->drawing_a), data->gc_old_ray,
		  data->xrays, data->no_rays);
  else
    data->new++;

  collisions(data);
  for (i=0; i<=data->no_hits; i++) {
    data->xrays[i].x1 = (short) (data->mag*data->Pos[i].x + data->offset.x);
    data->xrays[i].y1 = (short) (-data->mag*data->Pos[i].y + data->offset.y);
    data->xrays[i].x2 = (short) (data->mag*data->Pos[i+1].x + data->offset.x);
    data->xrays[i].y2 = (short) (-data->mag*data->Pos[i+1].y + data->offset.y);
  }
  data->no_rays = data->no_hits+1;
  XDrawSegments(dpy, XtWindow(data->drawing_a), data->gc_ray,
		  data->xrays, data->no_rays);

  WriteLabels(data, data->col, "Time");
}

void WriteLabels(data, str1, str2)
     Data *data;
     char *str1, *str2;
{
  XmString xstr;

  xstr = XmStringCreateSimple(str1);
  XtVaSetValues(data->label1, XmNlabelString, xstr, NULL);
  XmStringFree(xstr);
  xstr = XmStringCreateSimple(str2);
  XtVaSetValues(data->label2, XmNlabelString, xstr, NULL);
  XmStringFree(xstr);
}



void DrawingArea(data)
     Data *data;
{
  Dimension h, w, min;

  XtVaGetValues(data->drawing_a, XtNwidth, &w, XtNheight, &h, NULL);
  setv(data->offset, w/2, h/2);
  min = (h>w)? w:h;
  data->mag = data->factor*min;
  data->imag = 1.0/((double) data->mag);
}

void Clear(w, data, call_data)
     Widget w;
     Data *data;
     XtPointer call_data;
{
  WriteLabels(data, "Symbolic dynamics", "Time/Stability");
  DrawDisks(data);
  DrawTarget(data);
  data->no_hits = data->no_raysPO = data->new = data->newPO = 0;
}

void Expose_cb(w, data, call_data)
     Widget w;
     Data *data;
     XtPointer call_data;
{
  WriteLabels(data, "Symbolic dynamics", "Time/Stability");
  DrawingArea(data);
  DrawDisks(data);
  DrawTarget(data);
  data->new = 0;
  data->new = data->newPO = 0;
  if (data->no_hits>=0)
    DrawRays(data);
  if (data->no_raysPO)
    periodic(data);
}

void Scale_cb(w, data, call_data)
     Widget w;
     Data *data;
     XmScaleCallbackStruct *call_data;
{
  if (call_data->value==33)
    data->a = 1.0/6.0;
  else
    data->a = 0.005*call_data->value;
  data->ia = 1.0/data->a;
  data->asq = data->a*data->a;
  DrawDisks(data);
  DrawTarget(data);
  data->new = data->newPO = 0;
  if(data->poincare)
    P_Expose_cb(w, data, NULL);
}

void Mag_Scale_cb(w, data, call_data)
     Widget w;
     Data *data;
     XmScaleCallbackStruct *call_data;
{
  data->factor = 0.01*call_data->value;
  DrawingArea(data);
  DrawDisks(data);
  DrawTarget(data);
  data->new = data->newPO = 0;
  if (data->no_hits>=0)
    DrawRays(data);
  if (data->no_raysPO)
    periodic(data);
}

void Orbit_cb(widget, client_data, call_data)
     Widget widget;
     XtPointer client_data;
     XtPointer call_data;
{
  Widget dialog, toggle_box;
  XmString t = XmStringCreateSimple ("Enter Symbolic Orbit:");
  XmString btn1, btn2;
  Arg args[5];
  int n = 0;

  XtSetArg (args[n], XmNselectionLabelString, t); n++;
  XtSetArg (args[n], XmNautoUnmanage, False); n++;
  dialog = XmCreatePromptDialog (widget, "prompt", args, n);
  XmStringFree (t);

  XtAddCallback (dialog, XmNokCallback, read_name, client_data);

  XtAddCallback (dialog, XmNcancelCallback, cancel_cb, NULL);

  /* No help is available... */
  XtUnmanageChild(
	  XmSelectionBoxGetChild (dialog, XmDIALOG_HELP_BUTTON));

  bt_flag = 1;
  btn1 = XmStringCreateSimple ("Binary Representation");
  btn2 = XmStringCreateSimple ("Ternary Representation");
  toggle_box = XmVaCreateSimpleRadioBox (dialog,
	"radio_box", 0 /* inital value */, toggle_cb,
        XmVaRADIOBUTTON, btn1, 0, NULL, NULL,
        XmVaRADIOBUTTON, btn2, 0, NULL, NULL,
        NULL);
  XmStringFree (btn1);
  XmStringFree (btn2);
  XtManageChild (toggle_box);

  XtManageChild (dialog);

  XtPopup (XtParent (dialog), XtGrabNone);
}

void toggle_cb(toggle_box, client_data, call_data)
     Widget toggle_box;
     XtPointer client_data;
     XtPointer call_data;
{
    long n = (long) client_data;
    XmToggleButtonCallbackStruct *cbs = 
        (XmToggleButtonCallbackStruct *) call_data;

    if (cbs->set == False)
        return; /* wait for the one that toggles "on" */
    if (n == 0)
      bt_flag = 1;
    else
      bt_flag = 0;
}

void cancel_cb(widget, client_data, call_data)
     Widget widget;
     XtPointer client_data;
     XtPointer call_data;
{
  XtDestroyWidget(widget);
}

/* read_name() --the text field has been filled in. */
void read_name(widget, client_data, call_data)
     Widget widget;
     XtPointer client_data;
     XtPointer call_data;
{
    XmSelectionBoxCallbackStruct *cbs = 
        (XmSelectionBoxCallbackStruct *) call_data;
    Data *data = (Data *) client_data;
    char *str, old;
    int i, slen;

    XmStringGetLtoR (cbs->value, XmSTRING_DEFAULT_CHARSET, &str);
    slen = strlen(str);
    if (bt_flag) {
      data->type = 'b';
      data->bin_period = slen;
      for(i=0; i<slen; i++)  {
	if (str[i]=='0' || str[i]=='1')
	  data->bin_orbit[i] = str[i] - '0';
	else {
	  fprintf(stderr, "error: %s is an illegal orbit\n", str);
	  return;
	}
      }
    } else {
      data->type = 't';
      data->period = slen;
      old = str[slen-1];
      for(i=0; i<slen; i++) {
	if(str[i]<'1' || str[i]>'3' || str[i]==old) {
	  fprintf(stderr, "error: %s is an illegal orbit\n", str);
	  return;
	}
	data->orbit[i] = str[i] - '1';
	old = str[i];
      }
    }
      
    periodic(data);

    /* XtDestroyWidget(widget); */
}
