#include <Xm/DrawingA.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <Xm/Scale.h>
#include <Xm/Label.h>
#include <Xm/PanedW.h>
#include <Xm/SelectioB.h>
#include <Xm/DialogS.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define INF_T  10000.0
#define NO_HIT 100
#define ND 3
#define PI 3.14159265358979323846
#define setv(v, x1, y1) {v.x = x1; v.y = y1;}
#define setvv(v, w) {v.x = w.x; v.y = w.y;}
#define copyv(v, w) {v.x = w.x; v.y = w.y;}
#define dotv(v1, v2) (v1.x*v2.x + v1.y*v2.y)
#define hypotv(v) hypot(v.x, v.y)
#define smulv(v1, a, v2) {v1.x=a*v2.x; v1.y=a*v2.y;}
#define subv(v1, v2, v3) {v1.x=v2.x-v3.x; v1.y=v2.y-v3.y;}
#define addv(v1, v2, v3) {v1.x=v2.x+v3.x; v1.y=v2.y+v3.y;}
#define addvx(v1, v2, x1, y1) {v1.x=v2.x+x1; v1.y=v2.y+y1;}
#define addtov(v, x1, y1) {v.x=v.x+x1; v.y=v.y+y1;}
#define linear(v, a, va, b, vb) {v.x=a*va.x+b*vb.x; v.y=a*va.y+b*vb.y;}
#define polar(v, r, theta) {v.x=r*cos(theta); v.y=r*sin(theta);}
#define printv(v) printf("(%f, %f)", v.x, v.y)

#define INF_T  10000.0
#define NO_HIT 100
#define ND 3
#define LEN 0.2886751345948129
#define MAX_HIT 100
#define MAX_ORBIT 100
#define NO_COL 20
#define OFFSETX1 150
#define OFFSETX2 50
#define OFFSETY1 50
#define OFFSETY2 50
#define PI 3.14159265358979323846
#define dran() random()*4.656612873e-10

void init(), drawing_area_cb(), Clear(), collisions(), Expose_cb();
void DrawDisks(), DrawTarget(), DrawRays(), DrawingArea(), Scale_cb();
void Mag_Scale_cb(), Orbit_cb(), read_name(), periodic();
void WriteLabels(), cancel_cb(), toggle_cb(), Poincare_cb();
void SetTwoColours();
int SetColour();

typedef struct _Coord {
  int x;
  int y;
} Coord;

typedef struct _Vector {
  double x;
  double y;
} Vector;

typedef struct {
  Vector bl;
  Vector tr;
} Range;

typedef struct _Data {
  Vector disk[ND], target;
  double a, asq, ia;
  Coord offset;
  double mag, imag, factor;
  int no_hits, new, newPO;
  int no_rays, no_raysPO;
  Vector init_pos, init_vel;
  Vector Pos[MAX_HIT+3];
  Vector PosPO[MAX_HIT+3];
  char col[MAX_HIT+2];
  int  c_time[MAX_HIT+1], total_time;
  XSegment xrays[MAX_HIT+1];
  XSegment xraysPO[MAX_HIT+1];
  char *orbit, *bin_orbit;
  char type;
  int bin_period, period;
  int square;
  Coord size, no_sq;
  char **P_col;
  XRectangle *rect;
  Range range[100], limit_range;
  int n_range;
  char poincare_type;
  int poincare;

  GC gc, gc_map[NO_COL];
  Widget dialog, map;
  XFontStruct *font_info;

  Widget drawing_a, label1, label2, scale, mag_scale;
  GC gc_ray, gc_old_ray, gc_disk, gc_target1, gc_target2;
  GC gc_orbit, gc_old_orbit;
} Data;

